package example;

import com.agenarisk.api.io.JSONAdapter;
import com.agenarisk.api.model.DataSet;
import com.agenarisk.api.model.Model;
import com.agenarisk.api.model.Network;
import com.agenarisk.api.util.JSONUtils;
import org.json.JSONArray;
import org.json.JSONObject;

/**
 *
 * @author Eugene Dementiev
 */
public class MyApp {
	public static void main(String[] args) throws Exception {
		//Model model = Model.loadModel("Asia.json"); // This method only allows loading from json or cmpx. Loading from cmp and ast not yet supported, so have to use old api load
		// If using the old API, can use this method to convert the old API model into new API model
		Model model = Model.createModel(uk.co.agena.minerva.model.Model.load("Asia.ast"));
		
		
		
		Network net1 = model.getNetwork("Asia_0");
		DataSet ds = model.getDataSet("Scenario 1");
		
		ds.setObservationHard(net1.getNode("A"), "no");
		ds.setObservationHard(net1.getNode("S"), "yes");
		ds.setObservationHard(net1.getNode("X"), "no");
		ds.setObservationHard(net1.getNode("D"), "yes");
		
		model.calculate();
		
		//System.out.println(ds.getCalculationResults()); // This isn't implemented yet, need to convert underlying model to json and extract results from json directly
		
		JSONObject json = JSONAdapter.toJSONObject(model.getLogicModel());
		
		// Get only results
		JSONArray results = json
			.optJSONObject("model")
			.optJSONArray("dataSets")
			.optJSONObject(0)
			.optJSONArray("results");
		
		System.out.println(results.toString(10));
		
		// Direct result lookup also not yet implemented, so need to search for it
		System.out.println("Chance of cancer:");
		JSONUtils.traverse(results, o -> {
			if (o instanceof JSONObject){
				JSONObject jo = (JSONObject) o;
				if (jo.has("node") && jo.optString("node").equals("L")){
					JSONUtils.traverse(jo.optJSONArray("resultValues"), o2 -> {
						if (o2 instanceof JSONObject){
							JSONObject jo2 = (JSONObject) o2;
							if (jo2.has("label") && jo2.optString("label").equals("yes")){
								System.out.println(jo2.optDouble("value"));
							}
						}
					});
				}
			}
		});
	}
}
